﻿package  
{
	
	//{imports
	import flash.utils.describeType;
	//}
	
	/**
	* CSSManager class.
	* @author wvxvw
	* @langVersion 3.0
	* @playerVersion 10.0.12.36
	*/
	public class CSSManager 
	{
		//--------------------------------------------------------------------------
		//
		//  Private properties
		//
		//--------------------------------------------------------------------------
		
		// Just some test CSS declaration. You will probably want to expand that 
		// to be embedded or loaded at runtime.
		private static var _styles:XML =
		<![CDATA[
		AnotherStyle
		{
			foo: bar;
		}
		CSSSprite 
		{
			bounds: 50, 100, 150, 150;
			color: #FFFF00;
			some-unrelated-property: whatever
		}
		YetAnotherStyle {}
		]]>;
		
		//--------------------------------------------------------------------------
		//
		//  Cunstructor
		//
		//--------------------------------------------------------------------------
		
		public function CSSManager() { super(); }
		
		//--------------------------------------------------------------------------
		//
		//  Public methods
		//
		//--------------------------------------------------------------------------
		
		public static function styleObject(object:ICSSClient):void
		{
			var className:String = object.className;
			// We simplify CSS parsing as much as possible.
			// You will probaly want to implement
			// your own parsing routine.
			var declarations:String = _styles.toString().replace(/[\r\n\t]*/g, "");
			var declarationRE:RegExp = new RegExp(className + "\\s*\\\{[^\\\}]*\\\}", "g");
			var declaration:String = declarations.match(declarationRE)[0];
			declaration = declaration.match(/([^\}\{]*)\}/)[1];
			var props:Object = { };
			var propsDeclarations:Array = declaration.split(";");
			var prop:String;
			var val:String;
			var pair:Array;
			// Here we look for the metadata declarations stored with our class.
			var applicableStyles:XMLList = describeType(object).metadata.(@name == "CSS").arg;
			var keys:Array = [];
			applicableStyles.@key.(keys.push(toXMLString()));
			var p:String
			for each(p in propsDeclarations)
			{
				pair = p.split(":");
				prop = pair[0];
				val = pair[1];
				// Filter properties that aren't related to our style client.
				// We could also check here for default values, 
				// e.g. if the value in <code>@value</code> attribute is the same as the one 
				// we want to assign, we may also skip that style property.
				if (keys.indexOf(prop) < 0) continue;
				props[prop] = val;
			}
			for (p in props)
			{
				// Here you want to parse values from string and convert them
				// To the appropriate types.
				// But for the sake of simplicity we will assigns
				// strings and handle the parsing on the ICSSClient's side.
				object[p] = props[p];
			}
		}
	}
}