﻿package  
{
	//{imports
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Rectangle;
	import flash.utils.getQualifiedClassName;
	//}
	
	// See the rectangular shape drawn in different coordinates
	// with different dimensions.
	[CSS(bounds="0,0,100,100")] 
	// Violet, see it is set to yellow once we apply styling.
	[CSS(color="#FF00FF")] 
	
	/**
	* CSSSprite class.
	* @author wvxvw
	* @langVersion 3.0
	* @playerVersion 10.0.12.36
	*/
	public class CSSSprite extends Sprite implements ICSSClient
	{
		//--------------------------------------------------------------------------
		//
		//  Public properties
		//
		//--------------------------------------------------------------------------
		
		//------------------------------------
		//  Public property bounds
		//------------------------------------
		
		private var _bounds:String;
		
		[Bindable("boundsChange")]
		
		/**
		* ...
		* This property can be used as the source for data binding.
		* When this property is modified, it dispatches the <code>boundsChange</code> event.
		*/
		public function get bounds():String { return _bounds; }
		
		public function set bounds(value:String):void 
		{
		   if (_bounds == value) return;
		   _bounds = value;
		   var temp:Array = value.split(/\s*,\s*/);
		   boundsRect = new Rectangle(Number(temp[0]), Number(temp[1]), 
							Number(temp[2]), Number(temp[3]));
		   dispatchEvent(new Event("boundsChange"));
		   // You usually would like to deffer draw() untill
		   // the next screen update, but we don't want to 
		   // overcomplicate this example.
		   draw();
		}
		
		//------------------------------------
		//  Public property color
		//------------------------------------
		
		private var _color:String;
		
		[Bindable("colorChange")]
		
		/**
		* ...
		* This property can be used as the source for data binding.
		* When this property is modified, it dispatches the <code>colorChange</code> event.
		*/
		public function get color():String { return _color; }
		
		public function set color(value:String):void 
		{
		   if (_color == value) return;
		   _color = value;
		   colorStyle = parseInt(value.match(/[\dABCDEF]+/ig)[0], 16);
		   dispatchEvent(new Event("colorChange"));
		   draw();
		}
		
		//--------------------------------------------------------------------------
		//
		//  Protected properties
		//
		//--------------------------------------------------------------------------
		
		protected var boundsRect:Rectangle;
		protected var colorStyle:uint;
		
		//--------------------------------------------------------------------------
		//
		//  Cunstructor
		//
		//--------------------------------------------------------------------------
		public function CSSSprite() 
		{
			super();
			CSSManager.styleObject(this);
		}
		
		/* INTERFACE ICSSClient */
		
		public function get className():String
		{
			var temp:String = getQualifiedClassName(this);
			if (temp.indexOf(":") < 0) return temp;
			return temp.replace(/.*([^:]+$)/, "$1");
		}
		
		//--------------------------------------------------------------------------
		//
		//  Public methods
		//
		//--------------------------------------------------------------------------
		
		public function draw():void
		{
			// we don't set initializers, though, usually you'd like to have those
			// so you could draw as soon as the object is created.
			if (!boundsRect) return; 
			graphics.clear();
			graphics.beginFill(colorStyle);
			graphics.drawRect(boundsRect.x, boundsRect.y, 
						boundsRect.width, boundsRect.height);
			graphics.endFill();
		}
	}
}